#include <bits/stdc++.h>

using namespace std;


int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, m, t;
    cin >> n >> m >> t;
    vector<int> v(n), ans(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
    }
    for (int i = 0; i < n; i++) {
        int cnt = 0;
        if (i == 3) {
            cnt = 0;
        }
        for (int j = i; j < n; j++) {
            if (cnt > t) {
                break;
            }
            ans[i] = max((j - i) + (t - cnt) / v[j], ans[i]);
            cnt += v[j];
        }
        cnt = 0;
        for (int j = i; j >= 0; j--) {
            if (cnt > t) {
                break;
            }
            ans[i] = max(ans[i], i - j + (t - cnt) / v[i]);
            cnt += v[j];
        }
    }
    int res = 0;
    for (int i = 0; i < m; i++) {
        int x;
        cin >> x;
        res = max(res, ans[x - 1]);
    }
    cout << res;
}
